//+------------------------------------------------------------------+
//|                                               Trade_repeater.mq4 |
//|                                  Copyright 2020, Mike Robertson  |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, Mike Robertson"
#property link      "https://www.mql5.com"
#property version   "2.00"

#include <Trade/SymbolInfo.mqh> 

ulong ticket, Ticket[126];
double sl, tp, SL[126], TP[126];

input ulong MagicNumber = 625;
input int ExpirationMinutes = 5555555;
input int Slippage = 2;
input int Chusion = 10;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//initializing Note
   Alert(" Trade Repeater Activated. Happy Trading :) ") ;
   //double price = SymbolInfoDouble(_Symbol, SYMBOL_ASK);
   //int Eticket = SendOrder(_Symbol,ORDER_TYPE_BUY,0.1,price,Slippage,price-200*_Point,price+100*_Point,NULL,MagicNumber) ;

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
// Closing Note.
   Alert(" Expert Closed.! ") ;

  }
  
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  if (PositionsTotal() == 0)
  {
  int a = 0;
  }
   string symbol = ChartSymbol(0) ;
  
// Defining Counter for array
   static int Counter = 125 ;
   if(Counter<1 )
      Counter=125;

// Selecting and storing order
   
       if ( OrderStoring())
      {    
           Ticket[Counter]= Ticket[Counter-1] ;
           SL[Counter]= SL[Counter-1];
           TP[Counter]= TP[Counter-1];
           Ticket[Counter]= ticket ;
           SL[Counter]= sl ;
           TP[Counter]= tp ;
           
              Counter -- ;
      
      
               
  
              }
              
           

        
    /*
  Print ( "ticket at Index 0 =" +Ticket[0] ) ;
  Print ( "ticket at Index 1 =" +Ticket[1] ) ;
  Print ( "ticket at Index 123 =" +Ticket[123] ) ;
  Print ( "ticket at Index 5 =" +Ticket[5] ) ;
  Print ( "ticket at Index 95 =" +Ticket[95] ) ;
  Print ( "ticket at Index 100 =" +Ticket[100] ) ;
  Print ( "ticket at Index 122 =" +Ticket[122] ) ;
  Print ( "ticket at Index 0 =" +Ticket[0] ) ;
  Print ( "ticket at Index 120 =" +Ticket[120] ) ;
  Print ( "ticket at Index 125 =" +Ticket[125] ) ;
*/

      //  Preventing sending Multiple orders
     

      // Selecting last closed order

      HistorySelect(0, TimeCurrent()+999);
      int hstTotal=HistoryOrdersTotal();

      for ( int i=0 ; i<hstTotal; i++)
      {
      ulong Tickett = HistoryOrderGetTicket(i);
      bool  HCheck = Tickett > 0;
      
      if(HCheck)
        {
         int Lastticket = (int)HistoryOrderGetInteger(Tickett, ORDER_POSITION_ID);
         for(int j=125 ; j>0; j--)
           {
           
            if(Ticket[j] == Lastticket)

              {

               string comment = HistoryOrderGetString(Tickett, ORDER_COMMENT);

               if(StringFind(comment, "[tp ") == 0 || StringFind(comment, "[sl ") == 0
                  || StringFind(comment, "tp ") == 0 || StringFind(comment, "sl ") == 0
                 )      // Checking if order was closed with tp/sl
                 {
                 double Closeprice = HistoryOrderGetDouble(Tickett, ORDER_PRICE_CURRENT) ;
                 bool IsTP = StringFind(comment, "[tp ") == 0 || StringFind(comment, "tp ") == 0;
                 
                      Ticket[j] =0 ;
                 
               for ( int k=i-1 ; k>=0; k--)
               {
               Tickett = HistoryOrderGetTicket(k);
               if (Lastticket != (int)HistoryOrderGetInteger(Tickett, ORDER_POSITION_ID)) continue;
               
               ENUM_ORDER_TYPE Type = (ENUM_ORDER_TYPE) HistoryOrderGetInteger(Tickett, ORDER_TYPE) ;      // 0= buy , 1 = Sell
               bool IsBuy = (Type == ORDER_TYPE_BUY || Type == ORDER_TYPE_BUY_LIMIT || Type == ORDER_TYPE_BUY_STOP);
               double SL_ = SL[j] ;
               double TP_ =  TP[j] ;
               double Price = HistoryOrderGetDouble(Tickett, ORDER_PRICE_CURRENT) ;
               double point = SymbolInfoDouble(symbol, SYMBOL_POINT);
               
               double LotSize = HistoryOrderGetDouble(Tickett, ORDER_VOLUME_INITIAL) ;
               Print("Price", Price) ;
               Print("Closeprice", Closeprice) ;
               Print("Type", Type) ;
               Print("SL", SL_) ;
               Print("TP", TP_) ;
               Print(" COMMENT = ", comment) ;

                  if(IsBuy)
                    {
                     int Eticket = SendOrder(symbol,(IsTP ? ORDER_TYPE_BUY_LIMIT : ORDER_TYPE_BUY_STOP),LotSize,Price,Slippage,SL_,TP_,NULL,MagicNumber) ;
                     if(Eticket < 0)
                       {
                        Print("order rejected. Order error: " + (string)(-Eticket));

                        // Error Handling
                        double level = (SymbolInfoInteger(symbol,SYMBOL_TRADE_STOPS_LEVEL)+20) * point  ;
                        double Entryprice = Price - Chusion * point ;
                        Eticket = SendOrder(symbol,(IsTP ? ORDER_TYPE_BUY_LIMIT : ORDER_TYPE_BUY_STOP),LotSize,Entryprice,Slippage,0,0,NULL,MagicNumber) ;
                        if(Eticket < 0)
                          {
                           Print("order rejected. Order error: " + (string)(-Eticket));
                          }
                        else
                           Alert("Order Sent Succsessfully with modified Parameters ") ;

                       }
                    }
                  else
                    {
                     int Eticket =  SendOrder(symbol,(IsTP ? ORDER_TYPE_SELL_LIMIT : ORDER_TYPE_SELL_STOP),LotSize,Price,Slippage,SL_,TP_,NULL,MagicNumber) ;
                     if(Eticket < 0)
                       {
                        Print("order rejected. Order error: " + (string)(-Eticket));
                        // Error Handling
                        double level = (SymbolInfoInteger(symbol,SYMBOL_TRADE_STOPS_LEVEL)+20) * point  ;
                        double Entryprice = Price + Chusion * point ;
                        Eticket =  SendOrder(symbol,(IsTP ? ORDER_TYPE_SELL_LIMIT : ORDER_TYPE_SELL_STOP),LotSize,Entryprice,Slippage,0,0,NULL,MagicNumber) ;
                        if(Eticket < 0)
                          {
                           Print("order rejected. Order error: " + (string)(-Eticket));
                          }
                        else
                           Alert("Order Sent Succsessfully with modified Parameters ") ;

                       }
                    }
                    
                 break;
                 
                 }
                 
                 }
              }

           }
        }
        }
     
     
  }




//+------------------------------------------------------------------+

//+------------------------------------------------------------------+


// Function to prevent Multiple order sending error

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool Checkorders(int magicnumber)
  {
   
   int openorders= PositionsTotal() ;
   for(int i= 0 ; i<openorders; i++)
     {
      if(PositionGetTicket(i) > 0)
        {
         if(PositionGetInteger(POSITION_MAGIC) == magicnumber)
           {
            return true ;
            Alert(" position open ") ;
           }

        }

     }
   return false ;
  }


///******************************************************************************************************

//+------------------------------------------------------------------+
 bool OrderStoring()
  {
  int openorders= PositionsTotal() ;
  string symbol = ChartSymbol(0) ;
   for(int i= 0 ; i<openorders; i++)
     {
      if(PositionGetTicket(i) > 0)
        {
      double  Price = PositionGetDouble(POSITION_PRICE_OPEN) ;
      string  ordersymbol = PositionGetString(POSITION_SYMBOL) ;
       if ( ordersymbol == symbol )
      {
      
     ENUM_POSITION_TYPE Type = (ENUM_POSITION_TYPE) PositionGetInteger(POSITION_TYPE) ;      // 0= buy , 1 = Sell
     if ( Type == POSITION_TYPE_BUY || Type == POSITION_TYPE_SELL )
     { 
     
       ticket = PositionGetInteger(POSITION_TICKET) ;
       sl = PositionGetDouble(POSITION_SL) ;
       tp = PositionGetDouble(POSITION_TP) ;
     
if( ticket!=  Ticket[0] && ticket!=  Ticket[1] &&ticket!=  Ticket[2] &&ticket!=  Ticket[3] &&ticket!=  Ticket[4] &&ticket!=  Ticket[5] &&ticket!=  Ticket[6] &&ticket!=  Ticket[7] &&ticket!=  Ticket[8] &&ticket!=  Ticket[9] && ticket!=  Ticket[10] &&ticket!=  Ticket[11] &&ticket!=  Ticket[12] &&ticket!=  Ticket[13] &&ticket!=  Ticket[14] &&ticket!=  Ticket[15] &&ticket!=  Ticket[16] &&ticket!=  Ticket[17]&&ticket!=  Ticket[18] && ticket!=  Ticket[19] &&ticket!=  Ticket[20] &&ticket!=  Ticket[21] &&ticket!=  Ticket[22] &&ticket!=  Ticket[23] &&ticket!=  Ticket[24] &&ticket!=  Ticket[25] &&ticket!=  Ticket[26]&&ticket!=  Ticket[27] && ticket!=  Ticket[28] &&ticket!=  Ticket[29] &&ticket!=  Ticket[30] &&ticket!=  Ticket[31] &&ticket!=  Ticket[32] &&ticket!=  Ticket[33] &&ticket!=  Ticket[34] &&ticket!=  Ticket[35]&&ticket!=  Ticket[36] && ticket!=  Ticket[37] &&ticket!=  Ticket[38] &&ticket!=  Ticket[39] &&ticket!=  Ticket[40] &&ticket!=  Ticket[41] &&ticket!=  Ticket[42] &&ticket!=  Ticket[43] &&ticket!=  Ticket[44]&&ticket!=  Ticket[45] && ticket!=  Ticket[46] &&ticket!=  Ticket[47] &&ticket!=  Ticket[48] &&ticket!=  Ticket[49] &&ticket!=  Ticket[50] &&ticket!=  Ticket[51] &&ticket!=  Ticket[52] &&ticket!=  Ticket[53]&&ticket!=  Ticket[54] && ticket!=  Ticket[55] &&ticket!=  Ticket[56] &&ticket!=  Ticket[57] &&ticket!=  Ticket[58] &&ticket!=  Ticket[59] &&ticket!=  Ticket[60] &&ticket!=  Ticket[61] &&ticket!=  Ticket[62]&&ticket!=  Ticket[63] && ticket!=  Ticket[64] &&ticket!=  Ticket[65] &&ticket!=  Ticket[66] &&ticket!=  Ticket[67] &&ticket!=  Ticket[68] &&ticket!=  Ticket[69] &&ticket!=  Ticket[70] &&ticket!=  Ticket[71]&&ticket!=  Ticket[72] && ticket!=  Ticket[73] &&ticket!=  Ticket[74] &&ticket!=  Ticket[75] &&ticket!=  Ticket[76] &&ticket!=  Ticket[77] &&ticket!=  Ticket[78] &&ticket!=  Ticket[79] &&ticket!=  Ticket[80]&&ticket!=  Ticket[81] && ticket!=  Ticket[82] &&ticket!=  Ticket[83] &&ticket!=  Ticket[84] &&ticket!=  Ticket[85] &&ticket!=  Ticket[86] &&ticket!=  Ticket[87] &&ticket!=  Ticket[88] &&ticket!=  Ticket[89]&&ticket!=  Ticket[90] && ticket!=  Ticket[91] &&ticket!=  Ticket[92] &&ticket!=  Ticket[93] &&ticket!=  Ticket[94] &&ticket!=  Ticket[95] &&ticket!=  Ticket[96] &&ticket!=  Ticket[97] &&ticket!=  Ticket[98]&&ticket!=  Ticket[99] && ticket!=  Ticket[100] &&ticket!=  Ticket[101] &&ticket!=  Ticket[102] &&ticket!=  Ticket[103] &&ticket!=  Ticket[104] &&ticket!=  Ticket[105] &&ticket!=  Ticket[106] &&ticket!=  Ticket[107]&&ticket!=  Ticket[108] && ticket!=  Ticket[109] &&ticket!=  Ticket[110] &&ticket!=  Ticket[111] &&ticket!=  Ticket[112] &&ticket!=  Ticket[113] &&ticket!=  Ticket[114] &&ticket!=  Ticket[115] &&ticket!=  Ticket[116]&&ticket!=  Ticket[117] && ticket!=  Ticket[118] &&ticket!=  Ticket[119] &&ticket!=  Ticket[120] &&ticket!=  Ticket[121] &&ticket!=  Ticket[122] &&ticket!=  Ticket[123] &&ticket!=  Ticket[124] &&ticket!=  Ticket[125] )
      
      return true ;}
      }
    
      }
      
      }
      return false ;
      }
      

int SendOrder(const string sSymbol, const ENUM_ORDER_TYPE eType, const double fLot, double &prices, const uint nSlippage = 1000, const double fSL = 0, const double fTP = 0, const string nComment = "", const ulong nMagic = 0, datetime expiration=0)
{
	int RetVal = 0;

   string position_symbol = sSymbol;

	MqlTradeRequest trade_request = {};
	MqlTradeResult	 trade_result = {};
	
   if((int) SymbolInfoInteger(position_symbol, SYMBOL_FILLING_MODE)==SYMBOL_FILLING_FOK) trade_request.type_filling = ORDER_FILLING_FOK;
   else if((int) SymbolInfoInteger(position_symbol, SYMBOL_FILLING_MODE)==SYMBOL_FILLING_IOC) trade_request.type_filling = ORDER_FILLING_IOC;
   else if((int) SymbolInfoInteger(position_symbol, SYMBOL_FILLING_MODE)==0) trade_request.type_filling = ORDER_FILLING_RETURN;
   else if((int) SymbolInfoInteger(position_symbol, SYMBOL_FILLING_MODE)>2)
   {
      uint FillingCheck = FillingCheck(position_symbol);
      if(FillingCheck > 0) return(-(int)FillingCheck);
   }
	
	double fPoint = SymbolInfoDouble(sSymbol, SYMBOL_POINT);
	
	int nDigits	= (int) SymbolInfoInteger(sSymbol, SYMBOL_DIGITS);
	
   if(eType < 2) trade_request.action = TRADE_ACTION_DEAL;
   else trade_request.action =TRADE_ACTION_PENDING;
   
	trade_request.symbol		= sSymbol;
	trade_request.volume		= fLot;
	trade_request.stoplimit	= 0;
	trade_request.deviation	= nSlippage;
	trade_request.comment	= nComment;
	trade_request.type		= eType;
	trade_request.sl = (NormalizeDouble(fSL, nDigits));
   trade_request.tp = (NormalizeDouble(fTP, nDigits));
	trade_request.magic     = nMagic;
	if (expiration > 0)
	{
	   trade_request.type_time = ORDER_TIME_SPECIFIED;
	   trade_request.expiration = expiration;
	}
	if(eType == ORDER_TYPE_BUY) trade_request.price = NormalizeDouble(SymbolInfoDouble(sSymbol, SYMBOL_ASK), nDigits);
	else if(eType == ORDER_TYPE_SELL) trade_request.price = NormalizeDouble(SymbolInfoDouble(sSymbol, SYMBOL_BID), nDigits);
	else trade_request.price		= NormalizeDouble(prices, nDigits);
	          	
	MqlTradeCheckResult oCheckResult= {0};
	
	bool bCheck = OrderCheck(trade_request, oCheckResult);
	
	if(bCheck == true && oCheckResult.retcode == 0)
	{
		bool bResult = false;
		
		for(int k = 0; k < 5; k++)
		{
			bResult = OrderSend(trade_request, trade_result);

			if(bResult == true && (trade_result.retcode == TRADE_RETCODE_DONE || trade_result.retcode == TRADE_RETCODE_PLACED))
			{
 	         RetVal = (int)trade_result.order;   	         
   	      if (eType < 2 && PositionSelectByTicket(RetVal)) prices = PositionGetDouble(POSITION_PRICE_OPEN);
            else if (eType >= 2 && OrderSelect(RetVal)) prices = OrderGetDouble(ORDER_PRICE_OPEN);
            
				break;
			}
			if(k == 4)
			{
			   RetVal = -(int)trade_result.retcode;
				break;
			}	
			Sleep(1000);
		}
	}
	else 
	{
	   RetVal = -(int)oCheckResult.retcode;
   	if(oCheckResult.retcode == TRADE_RETCODE_NO_MONEY)
   	{
   		Print("Exper Removed due to not enough money!");
   		ExpertRemove();
   	}
	}
	
	return(RetVal);
}  

//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM\\
//+------------------------------------------------------------------+
//| Checks and corrects type of filling policy                       |
//+------------------------------------------------------------------+
uint FillingCheck(const string symbol)
{
   MqlTradeRequest   m_request={};         // request data
   MqlTradeResult    m_result={};          // result data

   ENUM_ORDER_TYPE_FILLING m_type_filling=0;
//--- get execution mode of orders by symbol
   ENUM_SYMBOL_TRADE_EXECUTION exec=(ENUM_SYMBOL_TRADE_EXECUTION)SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE);
//--- check execution mode
   if(exec==SYMBOL_TRADE_EXECUTION_REQUEST || exec==SYMBOL_TRADE_EXECUTION_INSTANT)
     {
      //--- neccessary filling type will be placed automatically
      return(m_result.retcode);
     }
//--- get possible filling policy types by symbol
   uint filling=(uint)SymbolInfoInteger(symbol,SYMBOL_FILLING_MODE);
//--- check execution mode again
   if(exec==SYMBOL_TRADE_EXECUTION_MARKET)
     {
      //--- for the MARKET execution mode
      //--- analyze order
      if(m_request.action!=TRADE_ACTION_PENDING)
        {
         //--- in case of instant execution order
         //--- if the required filling policy is supported, add it to the request
         if(m_type_filling==ORDER_FILLING_FOK && (filling & SYMBOL_FILLING_FOK)!=0)
           {
            m_request.type_filling=m_type_filling;
            return(m_result.retcode);
           }
         if(m_type_filling==ORDER_FILLING_IOC && (filling & SYMBOL_FILLING_IOC)!=0)
           {
            m_request.type_filling=m_type_filling;
            return(m_result.retcode);
           }
         //--- wrong filling policy, set error code
         m_result.retcode=TRADE_RETCODE_INVALID_FILL;
         return(m_result.retcode);
        }
      return(m_result.retcode);
     }
//--- EXCHANGE execution mode
   switch(m_type_filling)
     {
      case ORDER_FILLING_FOK:
         //--- analyze order
         if(m_request.action==TRADE_ACTION_PENDING)
           {
            //--- in case of pending order
            //--- add the expiration mode to the request
            if(!ExpirationCheck(symbol))
               m_request.type_time=ORDER_TIME_DAY;
            //--- stop order?
            if(m_request.type==ORDER_TYPE_BUY_STOP || m_request.type==ORDER_TYPE_SELL_STOP)
              {
               //--- in case of stop order
               //--- add the corresponding filling policy to the request
               m_request.type_filling=ORDER_FILLING_RETURN;
               return(m_result.retcode);
              }
            }
         //--- in case of limit order or instant execution order
         //--- if the required filling policy is supported, add it to the request
         if((filling & SYMBOL_FILLING_FOK)!=0)
           {
            m_request.type_filling=m_type_filling;
            return(m_result.retcode);
           }
         //--- wrong filling policy, set error code
         m_result.retcode=TRADE_RETCODE_INVALID_FILL;
         return(m_result.retcode);
      case ORDER_FILLING_IOC:
         //--- analyze order
         if(m_request.action==TRADE_ACTION_PENDING)
           {
            //--- in case of pending order
            //--- add the expiration mode to the request
            if(!ExpirationCheck(symbol))
               m_request.type_time=ORDER_TIME_DAY;
            //--- stop order?
            if(m_request.type==ORDER_TYPE_BUY_STOP || m_request.type==ORDER_TYPE_SELL_STOP)
              {
               //--- in case of stop order
               //--- add the corresponding filling policy to the request
               m_request.type_filling=ORDER_FILLING_RETURN;
               return(m_result.retcode);
              }
           }
         //--- in case of limit order or instant execution order
         //--- if the required filling policy is supported, add it to the request
         if((filling & SYMBOL_FILLING_IOC)!=0)
           {
            m_request.type_filling=m_type_filling;
            return(m_result.retcode);
           }
         //--- wrong filling policy, set error code
         m_result.retcode=TRADE_RETCODE_INVALID_FILL;
         return(m_result.retcode);
      case ORDER_FILLING_RETURN:
         //--- add filling policy to the request
         m_request.type_filling=m_type_filling;
         return(m_result.retcode);
     }
//--- unknown execution mode, set error code
   m_result.retcode=TRADE_RETCODE_ERROR;
   return(m_result.retcode);
}
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM\\  
//+------------------------------------------------------------------+
//| Check expiration type of pending order                           |
//+------------------------------------------------------------------+
bool ExpirationCheck(const string symbol)
  {
   CSymbolInfo sym;
   MqlTradeRequest   m_request={};         // request data
   MqlTradeResult    m_result={};          // result data

//--- check symbol
   if(!sym.Name((symbol==NULL)?Symbol():symbol))
      return(false);
//--- get flags
   int flags=sym.TradeTimeFlags();
//--- check type
   switch(m_request.type_time)
     {
      case ORDER_TIME_GTC:
         if((flags&SYMBOL_EXPIRATION_GTC)!=0)
            return(true);
         break;
      case ORDER_TIME_DAY:
         if((flags&SYMBOL_EXPIRATION_DAY)!=0)
            return(true);
         break;
      case ORDER_TIME_SPECIFIED:
         if((flags&SYMBOL_EXPIRATION_SPECIFIED)!=0)
            return(true);
         break;
      case ORDER_TIME_SPECIFIED_DAY:
         if((flags&SYMBOL_EXPIRATION_SPECIFIED_DAY)!=0)
            return(true);
         break;
      default:
         Print(__FUNCTION__+": Unknown expiration type");
         break;
     }
//--- failed
   return(false);
  }  